#if !defined(SQBEAPP_H)
#define SQBEAPP_H

#include <Application.h>
#include <Window.h>
#include <View.h>
#include <Path.h>

// BeOS application object
class SqueakApp : public BApplication {
	BPath PrefDirPath, GenPrefFilePath;
	void RunImage();
public:	
	SqueakApp();
	virtual void AboutRequested();
	virtual void ArgvReceived(int32 argc, char **argv);
	void LoadPreferences();
	virtual void RefsReceived(BMessage *message);
	virtual void ReadyToRun();
	void SavePreferences();
	virtual void Quit();
};
    
extern SqueakApp *SqApp;
extern BWindow *SqWindow;
extern BView *SqView;

extern thread_id InterpretThread; // thread for interpreter  
extern char ShortImageName[B_FILE_NAME_LENGTH]; // just the image file name
extern char VMPath[B_PATH_NAME_LENGTH]; // full path to interpreter's directory 
extern int *Pubargc; // public access argc (used by GetAttribute)
extern char ***Pubargv; // public access argv (used by GetAttribute)
extern int PubImageArg; // number of image argument (used by GetAttribute)
extern char *ProgName; // name of the VM file

void ShowAlert(const char *err);

#endif
