#if !defined(SQBECOPYBITS_H)
#define SQBECOPYBITS_H

#include <View.h>
#include <Screen.h>

void InitSqueakToBeColorMap(BScreen *screen);

// the CopyBits class is used for copying bitmaps between Squeak and display adapter/Be formats
class CopyBits {
	int Width, Height;
	int SrcDepth, DstDepth, DstXOff, DstYOff;
	bool IsBBitmap;
	color_space DstCS;
	unsigned char *Src, *Dst;
	int tx, DstTx, squeakBytesPerRow, beBytesPerRow;
	int binc, sqinc, sqinc_bit;	 
	int sqrbegin, sqrend;		
	int sqbegin_bit, sqbegin;
	int brbegin, brend, bbegin, bend;
	const color_map *cm;
	int left, top, right, bottom;
	void (CopyBits::*RectBlter)();

	void Copy1to8();
	void Copy1to15();
	void Copy1to16();
	void Copy1to32();
	void Copy2to8();
	void Copy2to15();
	void Copy2to16();
	void Copy2to32();
	void Copy4to8();
	void Copy4to15();
	void Copy4to16();
	void Copy4to32();
	void Copy8to8();
	void Copy8to15();
	void Copy8to16();
	void Copy8to32();
	void Copy16to8();
	void Copy16to15();
	void Copy16to16();
	void Copy16to32();
	void Copy32to8();
	void Copy32to15();
	void Copy32to16();
	void Copy32to32();
	void Swap1to8();
	void Swap1to15();
	void Swap1to16();
	void Swap1to32();
	void Swap2to8();
	void Swap2to15();
	void Swap2to16();
	void Swap2to32();
	void Swap4to8();
	void Swap4to15();
	void Swap4to16();
	void Swap4to32();
	void Swap8to8();
	void Swap8to15();
	void Swap8to16();
	void Swap8to32();
	void Swap16to8();
	void Swap16to15();
	void Swap16to16();
	void Swap16to32();
public:
	CopyBits(const color_map *aCM, int aSrcDepth, color_space aDstCS, 
		int aWidth, int aHeight, void *aSrc, void *aDst, 
		int aDstXOff = 0, int aDstYOff = 0, int aBeBytesPerRow = 0);
	int BeWidth();	
	void CopyRect(int left, int top, int right, int bottom);	
	void SetDst(void *aDst);
	void SetBeBytesPerRow(int aBeBytesPerRow);
};

#endif
