#if !defined(SQBEDIRECTWINDOW_H)
#define SQBEDIRECTWINDOW_H

#include <DirectWindow.h>
#include <Region.h>
#include <View.h>
 
// Squeak window, when in BDirectWindow mode
class SqueakDirectWindow : public BDirectWindow {
public:
	SqueakDirectWindow(BRect frame);
	~SqueakDirectWindow();
	virtual void	DirectConnected(direct_buffer_info *info);
	void	DrawThread();
	void	Invalidate(int left, int top, int right, int bottom);
	void	FrameResized(float width, float height);
	bool	QuitRequested();
	void	WindowActivated(bool active);
	void	DispatchMessage(BMessage *msg, BHandler *target);
private:
	uint8	*fBits;
	int32	fRowBytes;
	color_space	fFormat;
	clipping_rect	fBounds;
	BRegion	fClipRegion, fOldClipRegion, fDiffRegion;
	bool	fVisibleRegionChanged;
	bool	fConnected;
	bool	fConnectionDisabled;
	BLocker	*fLocker;
	
	// Squeak bitmap info
	uint8	*fSqBits;
	int32	fSqWidth, fSqHeight;
	int32	fSqDepth;
	int32	fSqRowBytes;
	BRegion	fSqDirtyRegion;
	const color_map *fColorMap;

	void	UpdateSqueakDisplayInfo(int bits, int width, int height, int depth);
};
	
#endif
