// this file contains: BeOS joystick support.
//
// author: Colin Sarsfield
//
// Please read the file named License for license information.
// 

#include "sqBeGlobal.h"
extern "C" {
	#include "JoystickTabletPlugin.h"
}
#include <Joystick.h>
	
bool sticks_setup = false;
int gameports_count, sticks_count;
BJoystick gameports[16];
struct joy_stick	
	{
	int gameport, stick;
	} sticks[16];

int joystickRead(int index)	
	{
	if (!sticks_setup) joystickInit();
	//printf("joystickRead(%d)\n", index);
	
	if (index < 1 || index > sticks_count)	
		return 0x200400;
		
	struct joy_stick this_stick = sticks[index - 1];		
   
	gameports[this_stick.gameport].Update();
   
	int ret = 1 << 5;
	
	// buttons
	int buttons = gameports[this_stick.gameport].ButtonValues(this_stick.stick);
	
	ret |= buttons & 0x1f;

	int axes_count;
	int16 *axes; 

	axes = (int16 *) malloc(sizeof(int16) * (axes_count = gameports[this_stick.gameport].CountAxes())); 
	gameports[this_stick.gameport].GetAxisValues(axes, this_stick.stick);
			
	// y
	ret <<= 11;
	if (axes_count >= 2)
		ret |= (axes[1] >> 5) + 0x400;
	// x
	ret <<= 11;
	if (axes_count >= 1)
		ret |= (axes[0] >> 5) + 0x400;
	free(axes);
	
	printf("joystickRead(%d) = %x\n", index, ret);
	return ret; 
	}

int joystickInit(void)		
	{ 
	printf("joystickInit\n");
	sticks_setup = true;
	int count = gameports[0].CountDevices();
	int portstickcount, i, j, err;
	gameports_count = sticks_count = 0;
	char joystick_name[B_OS_NAME_LENGTH];
	for (i = 0; i < count; i++)
		{
		err = gameports[0].GetDeviceName(i, joystick_name);
		printf("gameport[%d] = %s\n", i, joystick_name);
		if (err != B_OK)
			fprintf(stderr, "Error getting device name for gameport %d.\n", i);
		err = gameports[gameports_count].Open(joystick_name);
		if (err == B_ERROR)
			fprintf(stderr, "Error opening port for gameport %d.\n", i);
		portstickcount = gameports[gameports_count].CountSticks();
		printf("gameport[%d] = %d sticks\n", i, portstickcount);
		if (portstickcount)
			{
			for (j = 0; j < portstickcount; j++, sticks_count++)
				{
				sticks[sticks_count].gameport = gameports_count;
				sticks[sticks_count].stick = j;
				}
			gameports_count++;
			}
		else
			gameports[gameports_count].Close();
		} 
	printf("gameports = %d, sticks = %d\n", gameports_count, sticks_count);
	return 0; 
	}

int joystickShutdown(void) {
	return 1;
}

int tabletGetParameters(int cursorIndex, int result[]) {
	success(false);
}

int tabletRead(int cursorIndex, int result[]) {
	success(false);
}

int tabletResultSize(void)  {
	success(false);
}
