#include <Window.h>
#include <ListView.h>
#include <ScrollView.h>
#include "sqBeLogWindow.h"
#include "sqBeApp.h"
#include "sqBeGlobal.h"
#include <stdio.h>

bool ShowLogWindow = false;
BWindow *SqLogWindow = 0;
BMenuItem *LogWindowItem = 0;
BListView *list = 0;
BList log_items;

void CreateLogWindow();
void CreateLogWindow() {
	BRect r(50,50,400,250);
	SqLogWindow = new BWindow(r, "Log",B_TITLED_WINDOW,
		B_NOT_CLOSABLE | B_NOT_MINIMIZABLE);
	r.OffsetTo(0, 0);
	
	BView *v = new BView(r, "LogView", B_FOLLOW_ALL_SIDES, 0);
    v->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
    SqLogWindow->AddChild(v);
	
	r.InsetBy(5, 5);
	r.right -= B_V_SCROLL_BAR_WIDTH;
	//r.bottom -= B_H_SCROLL_BAR_HEIGHT;
	list = new BListView(r, "LogList", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL_SIDES);
	BScrollView *sv;
	v->AddChild(sv = new BScrollView("LogScroll", list, B_FOLLOW_ALL_SIDES, 0, false, true));
	
	int i, count;
	
	count = log_items.CountItems();
	for (i = 0; i < count; i++) {
		list->AddItem(new BStringItem((char *)log_items.ItemAt(i)), 0);
		delete (char *)log_items.ItemAt(i);
	}
	log_items.MakeEmpty();
}

void LogWindowSetVisibleTo(bool vis) {
	if (vis == ShowLogWindow) return;
	if (vis) {
		if (!SqLogWindow) CreateLogWindow();
		SqLogWindow->Show();
	}
	else if (SqLogWindow)
		SqLogWindow->Hide();
	if (LogWindowItem)
		LogWindowItem->SetMarked(vis);
	ShowLogWindow = vis;
}

void log_message(log_msg msg_type, char *msg) {
	if (msg_type != log_info && !ShowLogWindow)
		LogWindowSetVisibleTo(true);
	if (SqLogWindow) {
		if (SqLogWindow->Lock()) {
			list->AddItem(new BStringItem(msg), 0);		 
			SqLogWindow->Unlock();
		}
	}
	else {
		char *nstr = new char[strlen(msg) + 1];
		strcpy(nstr, msg);
		log_items.AddItem(nstr);
	}
	//fprintf(stderr, "%s\n", msg);
}

